package ru.amse.silina.cat.text.markers.impl;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import ru.amse.silina.cat.text.IText;

public abstract class FragmentsMarker {
	protected final Matcher myMatcher; 
	protected final IText myText;
	
	public FragmentsMarker(IText text, Pattern pattern) {
		myText = text;
		myMatcher = pattern.matcher(myText.getSourceText());
	}
	
	protected abstract void addMarked();
	
	public void markFragments() {
		boolean fragmentFound;
		do {
			fragmentFound = myMatcher.find();
			if (fragmentFound) {
				//System.out.println(myText.getSourceText().substring(myMatcher.));
				addMarked();
			}
		} while (fragmentFound);	
	}
	
}
