package ru.amse.silina.cat.ui;

import javax.swing.JOptionPane;

import ru.amse.silina.cat.text.IFragment;
import ru.amse.silina.cat.text.IText;
import ru.amse.silina.cat.text.impl.DeadSpace;
import ru.amse.silina.cat.text.impl.TranslatedFragment;
import ru.amse.silina.cat.ui.fragmentspane.IFragmentMarkListener;
import ru.amse.silina.cat.ui.fragmentspane.JFragmentsPane;

public class FragmentMarkListener implements IFragmentMarkListener {
	private JFragmentsPane mySourcePane;
	private JFragmentsPane myTargetPane;
	private CATFrame myFrame;
	
	public FragmentMarkListener(JFragmentsPane sourcePane, JFragmentsPane targetPane, CATFrame frame) {
		mySourcePane = sourcePane;
		myTargetPane = targetPane;
		myFrame = frame;
	}
	
	@Override
	public void fragmentMarked(int start, int end) {
		if (myFrame.addsTranslated()) {
			String translation = JOptionPane.showInputDialog("Input translation for your fragment");
			if (translation != null) {
				IFragment f;
				IText text = mySourcePane.getText();
				if (start < end) {
					f = new TranslatedFragment(start, end, translation, text);
				} else {
					f = new TranslatedFragment(end, start, translation, text);
				}
				text.addFragment(f);
				myFrame.setIsChanged(true);
				myTargetPane.getFragmentDataProvider().recalculateFragmentPositions();
				mySourcePane.repaint();
				myTargetPane.repaint();
			} else {
				myTargetPane.removeSelection();
				mySourcePane.removeSelection();
				mySourcePane.repaint();
				myTargetPane.repaint();
			}
		} else {
			IFragment f;
			IText text = mySourcePane.getText();
			if (start < end) {
				f = new DeadSpace(start, end, text);
			} else {
				f = new DeadSpace(end, start, text);
			}
			text.addFragment(f);
			myFrame.setIsChanged(true);
			myTargetPane.getFragmentDataProvider().recalculateFragmentPositions();
			mySourcePane.repaint();
			myTargetPane.repaint();
		}
	}
}
